var Editor = {
    idEditor: 'ace-editor',

    urlArbol: 'prontus_edit_arbol.cgi',
    urlFile: 'prontus_edit_file.cgi',
    urlGuardar: 'prontus_edit_guardar.cgi',
    urlBorrar: 'prontus_edit_borrar.cgi',
    urlUpload: 'prontus_edit_upload.cgi',
    urlCopiar: 'prontus_edit_copy.cgi',
    editorLoaded: false,
    aceEditor: null,
    snippetManager: null,
    textUploadName: '[nombre sin extensión]',

    init: function() {
        // Setea el Path
        var thePath = Editor.getParam(window.location.href, '_dir');
        var theFile = Editor.getParam(window.location.href, '_file');
        if (theFile !== '') {
            theFile = thePath + '/' + theFile;
        }
        Editor.cambiaPathActual(thePath, theFile);
        Utiles.instalaHandlerBuscador('#name_upload', Editor.textUploadName);

        var tipo = Admin.helper.getValueLS('prontus-editor-scroll');
        if (tipo != 'normal') {
            tipo = 'scroll';
        }
        Editor.setScrollArbol(tipo);

        $('#form-editor').on('click', 'a.link-scroll', function() {
            if ($(this).attr('href') == '#arbol-scroll') {
                Editor.setScrollArbol('scroll');
            } else {
                Editor.setScrollArbol('normal');
            }
        });

        $("#form-editor").on("click", "#borrar_directorio", function () {
            showModalConfirm(modal_borrar_directorio);
            return false;
        });

        $('#form-editor').on("click", '#menu-directorio-volver', function () {
            Editor.cambiaTabShortcut($(this).attr('data-dir_sup'));
        });

        $("#form-editor").on("click", '.datalink', function () {
            var datalink = $(this).attr('data-datalink');
            var datatipo = $(this).attr('data-datatipo');
            var newdatalink = datalink.replace(/^.*?&/g, "");

            if (datatipo.match("dir")) {
                //send dir,dirlink
                var dirlink = newdatalink.replace("_dir=", "");
                Editor.procesaArbol("dir", dirlink);
            } else {
                // send file,dirlink,filelink.
                dirlink = newdatalink.match(/_dir=.*&/i).toString();
                dirlink = dirlink.replace("&", "");
                dirlink = dirlink.replace("_dir=", "");

                var filelink = newdatalink.match(/&_file.*/i).toString();
                filelink = filelink.replace("&_file=", "");

                Editor.procesaArbol("file", dirlink, filelink);
            }
        });

        $('#form-editor').on('click', '#borrar_archivo', function () {
            Editor.accionBorrar();
            return false;
        });

        $('#form-editor').on('click', '#cerrar_archivo', function () {
            Editor.accionCerrar('img');
            return false;
        });

        $('#form-editor').on('click', '#showHelpSnippet', function () {
            Editor.showHelp('snippet', Admin.prontus_id);
            return false;
        });

        $('#form-editor').on('change', '#sel_marca_usr, #sel_marca_gral, #sel_marca_ctrl', function () {
            Editor.insertMarca(this);
        });

        $('#form-editor').on("click", '#modal_copiar_archivo', function () {
            showModalConfirm(nuevo_copiar_archivo);
        });

        $('#form-editor').on("click", '#modal_guardar_archivo', function () {
            showModalConfirm(modal_guardar);
        });

        $('#form-editor').on("click", '#modal_borrar_archivo', function () {
            showModalConfirm(modal_borrar);
        });

        $('#form-editor').on("click", '#modal_cerrar_archivo', function () {
            showModalConfirm(modal_cerrar);
        });

        $('#form-editor').on("click", '#modal_crear_directorio', function () {
            showModalConfirm(nuevo_crear_directorio);
        });

        $('#form-editor').on("click", '#modal_nuevo_archivo', function () {
            showModalConfirm(nuevo_nuevo_archivo);
        });

        $('#modal_subir_archivo').on('change', '#file_upload', function () {
            var archivo_a_subir = $('#file_upload').val();
            if (archivo_a_subir.match(/\./)) {
                $("#btn-subir-archivo").removeClass("disabled");
            } else {
                $("#file_upload").addClass("disabled");
            }
        });

        $('#showRootDirectory').on('click', function (e) {
            e.preventDefault();
            Editor.showRootDirectory();
        });

        $('#modal_subir_archivo').on('click', "#btn-subir-archivo", function () {
            if (! $('#btn-subir-archivo').hasClass('disabled')) {
                Editor.accionUpload();
                $("#modal_subir_archivo").modal('hide');
            }
        });

        // Combo-box
        $('.menu-carpetas li').on("click", "a", function () {
            var current_id = $(this).attr('id');
            var dir;
            switch (current_id) {
                case "menu-drop-archivos":
                    dir = "/" + Admin.prontus_id;
                    break;
                case "menu-drop-plantilla-articulos":
                    dir = "/" + Admin.prontus_id + "/plantillas/artic/fecha/pags";
                    break;
                case "menu-drop-macro-articulo":
                    dir = "/" + Admin.prontus_id + "/plantillas/artic/fecha/macros";
                    break;
                case "menu-drop-plantilla-portada":
                    dir = "/" + Admin.prontus_id + "/plantillas/edic/nroedic/port";
                    break;
                case "menu-drop-macro-portada":
                    dir = "/" + Admin.prontus_id + "/plantillas/edic/nroedic/macros";
                    break;
                case "menu-drop-fids":
                    dir = "/" + Admin.prontus_id + "/cpan/fid";
                    break;
                case "menu-drop-macro-fids":
                    dir = "/" + Admin.prontus_id + "/cpan/fid/macros";
                    break
                case "menu-drop-tag":
                    dir = "/" + Admin.prontus_id + "/plantillas/tag";
                    break;
                case "menu-drop-tax":
                    dir = "/" + Admin.prontus_id + "/plantillas/tax";
                    break;
                case "menu-drop-list":
                    dir = "/" + Admin.prontus_id + "/plantillas/list";
                    break;
            }
            Editor.cambiaTabShortcut(dir)
        });

        // Para snippets Prontus. Usa var global snippets, declarada en prontus_edit_main.html.
        $('#form-editor').on('change', '#sel_snippet', function () {
            var snippet_name = $(this).val();
            if (typeof snippet_name !== 'undefined' && snippet_name != '' && typeof snippets[snippet_name] !== 'undefined') {
                Editor.snippetManager.insertSnippet(Editor.aceEditor, snippets[snippet_name]);
            }
            return;
        });
    },
    showRootDirectory: function () {
        Editor.cambiaPathActual('/', '');
    },
    setScrollArbol: function(ahora) {
        var antes = '';
        if (ahora == 'scroll') {
            antes = 'normal';

            var h = window.innerHeight;
            if (h < 670) {
                $('.arbol-scroll').css('height', '200px');
            } else if (h > 670 && h < 768) {
                $('.arbol-scroll').css('height', '400px');
            } else {
                $('.arbol-scroll').css("height", "100%");
            }
            $('.arbol-scroll').css("overflow", "scroll");

        } else {
            ahora = 'normal';
            antes = 'scroll';
            $('.arbol-scroll').css("height", "100%");
            $('.arbol-scroll').css("overflow", "visible");
        }

        Admin.helper.setValueLS('prontus-editor-scroll', ahora);
        $('.link-scroll').hide();
        $('.tipo-' + antes).show();
    },

    // -------------------------------------------------------------------------
    initEditor: function(filetype) {
        var my_highlight;
        switch (filetype) {
            case "html":
                my_highlight = "ace/mode/php";
                break;
            case "js":
                my_highlight = "ace/mode/javascript";
                break;
            case "php":
                my_highlight = "ace/mode/php";
                break;
            case "css":
                my_highlight = "ace/mode/css";
                break;
            case "xml":
                my_highlight = "ace/mode/xml";
                break;
            case "pm":
            case "pl":
                my_highlight = "ace/mode/perl";
                break;
            default:
                my_highlight = "ace/mode/text";
        }
        // Aca se deja el loading
        $('#content-editor').prepend('<div class="list-loading" style="height:100px">&nbsp;</div>');

        // Se inicia el editor
        this.aceEditor = ace.edit("ace-editor");
        this.aceEditor.setOptions({
            mode: my_highlight,
            theme: 'ace/theme/chrome',
            enableSnippets: true,
            wrapBehavioursEnabled: true,
            wrap:true,
            maxLines: 100,
            minLines: 24,
            useWorker: false
        });
        //Se registran los snippets
        ace.config.loadModule('ace/ext/language_tools', function() {
            Editor.snippetManager = ace.require("ace/snippets").snippetManager;

            ace.config.loadModule("ace/snippets/html", function(m) {
                if (m) {
                    Editor.snippetManager.files.html = m;
                    m.snippets = Editor.snippetManager.parseSnippetFile(m.snippetText);
                    var newSnippets = Editor.getProntusSnippets();
                    newSnippets.forEach(function(s) {
                        m.snippets.push(s);
                    });
                    Editor.snippetManager.register(m.snippets, m.scope);
                }
            });
        });
        Editor.initEditorHandler('ace-editor');
    },

    // -------------------------------------------------------------------------
    initEditorHandler: function(id_editor) {
        // Se oculta el loading
        $('#content-editor .list-loading').remove();

        var h = window.innerHeight;
        if (h > 640 && h < 1215) {
            $('#' + Editor.idEditor).css('height', "650px");
        } else if (h < 640) {
            $('#' + Editor.idEditor).css('height', "330px");
        } else if (h >= 1215) {
            $('#' + Editor.idEditor).css('height', "980px");
        }

        // Se usa para saber cuando cargo exactamente el editor
        Editor.editorLoaded = true;
    },

    // -------------------------------------------------------------------------
    setTab: function() {
        var dir = $('#_curr_dir').val();
        $('#tabs2 a.selected').removeClass('selected');
        $('#tabs2 a').each(function() {
            var dirlink = Editor.getParam($(this).attr('href'), '_dir');
            if (dir == dirlink) {
                $(this).addClass('selected');
            }
        });
        if ($('#tabs2 a.selected').length < 1) {
            $('#tabs2 a:first').addClass('selected');
        }
    },

    // -------------------------------------------------------------------------
    procesaArbol: function(tipo, dirlink, filelink) {
        if (tipo == 'dir') {
            Editor.cambiaPathActual(dirlink);
        } else if (tipo == 'file') {
            var file = dirlink + '/' + filelink;
            if (dirlink == '/') {
                file = '/' + filelink;
            }
            Editor.cambiaArchivoActual(dirlink, file);
        } else {
            Admin.displayMessage('El tipo de Elemento no es válido', 'error');
        }
        return false;
    },

    // -------------------------------------------------------------------------
    cambiaTabShortcut: function(dirlink) {
        Editor.cambiaPathActual(dirlink);
    },

    // -------------------------------------------------------------------------
    setLinksPathActual: function(thePath) {
        if (thePath === '' || thePath == '/') {
            $('#dir_actual').html(thePath);
            return;
        }
        var arr = thePath.split('/');
        var total = arr.length;
        if (total < 2) {
            $('#dir_actual').html(thePath);
            return;
        }
        var theNewPath = '';
        var thePathReal = '';
        for (var k = 0; k < total; k++) {
            if (k > 0 && arr[k] != '') {
                thePathReal = thePathReal + '/' + arr[k];
                var lnk = 'prontus_edit_main.cgi?_prontus_id=' + Admin.prontus_id + '&amp;_dir=' + thePathReal;
                var onclk = "Editor.procesaArbol('dir','"+thePathReal+"');";
                theNewPath = theNewPath + ' <a href="' + lnk + '" onclick="' + onclk + ' return false;" title="Ir al directorio ' + thePathReal + '">/' + arr[k] + '</a>';
            }
        }

        $('#dir_actual').html(theNewPath);
    },

    // -------------------------------------------------------------------------
    cambiaPathActual: function(thePath, file) {
        if (typeof thePath === 'undefined' || typeof thePath === '') {
            return;
        }

        // Set Loadings y Candados
        if (Editor.loading) {
            return;
        }
        Editor.loading = true;
        $('#col-arbol').hide().html('<div class="list-loading" style="height:100px">&nbsp;</div>').show();

        // Se debería cargar el Arbol con Ajax
        var datos = {
            _prontus_id: Admin.prontus_id,
            _dir: thePath
        };
        $('#col-arbol').load(Editor.urlArbol, datos, function(responseText, textStatus, XMLHttpRequest) {
            Editor.setLinksPathActual(thePath);
            Editor.loading = false;
            if (textStatus == 'success') {
                // Una vez que el arbol está cargado, se setea el path y se pinta el tab
                $('#_curr_dir').val(thePath);
                Editor.setTab();

                // Si hay un archivo cargado, se pinta en el listado
                Editor.addStyleActual($('#_path_file').val());

                // Si se estaba cambiando para cargar un archivo, se carga dicho archivo
                if (typeof file !== 'undefined') {
                    Editor.cambiaArchivoActual(thePath, file);
                }
            } else {
                alert("Server error procesando request ajax:\nURL invocada:" +
                    thePath + "\ntextStatus=" +
                    textStatus + "\nresponseText=" +
                    responseText + "\nXMLHttpRequest.status=" +
                    XMLHttpRequest.status + '-' + XMLHttpRequest.statusText +
                    "\nXMLHttpRequest.responseText=" + XMLHttpRequest.responseText +
                    "\nResponseHeaders=" + XMLHttpRequest.getAllResponseHeaders());
            }
        });
    },

    // -------------------------------------------------------------------------
    cambiaArchivoActual: function(thePath, file) {
        // Se debe enviar si o si el archivo
        if (typeof file === 'undefined' || typeof file === '' || file.indexOf('..') >= 0) {
            $('#col-edit').hide().html('<div style="height:100px">&nbsp;</div>').show();
            return;
        }

        var dir = $('#_curr_dir').val();
        if (thePath != dir) {
            Editor.cambiaPathActual(thePath, file);
        }

        // Set Loadings y Candados
        if (Editor.loading) {
            return;
        }
        Editor.loading = true;
        if (Editor.editorLoaded) {
            this.aceEditor.destroy();
        }
        $('#col-edit').hide().html('<div class="list-loading" style="height:100px">&nbsp;</div>').show();

        // Se debería cargar el Arbol con Ajax
        var datos = {
            _prontus_id: Admin.prontus_id,
            _path_file: file,
            _dir: thePath
        };

        $('#col-edit').load(Editor.urlFile, datos, function(responseText, textStatus, XMLHttpRequest) {
            Editor.loading = false;
            if (textStatus == 'success') {
                Editor.addStyleActual(file);
                if ($('#' + Editor.idEditor).length == 1) {
                    var filename = file.match(/\.\S+/g);
                    filename = filename.toString();
                    filename = filename.replace(/.class/i, "");
                    filename = filename.replace(/\./i, "");
                    Editor.initEditor(filename);

                } else {
                    Editor.editorLoaded = false;
                }
            } else {
                alert("Server error procesando request ajax:\nURL invocada:" +
                    thePath + "\ntextStatus=" +
                    textStatus + "\nresponseText=" +
                    responseText + "\nXMLHttpRequest.status=" +
                    XMLHttpRequest.status + '-' + XMLHttpRequest.statusText +
                    "\nXMLHttpRequest.responseText=" + XMLHttpRequest.responseText +
                    "\nResponseHeaders=" + XMLHttpRequest.getAllResponseHeaders());
            }
        });
    },

    // -------------------------------------------------------------------------
    addStyleActual: function(file) {
        if (typeof file === 'undefined' || typeof file === '') {
            return;
        }
        // Se valida que estemos en el mismo directorio
        var currdir = $('#_curr_dir').val();
        var path = Editor.extractPath(file);
        if (currdir != path) {
            return;
        }
        // Se valida que el nombre de archivo coincida y se marca como selected
        var filename = Editor.extractFilename(file);
        $('#col-arbol .item').removeClass('selected').each(function() {
            if ($(this).text() == filename) {
                $(this).addClass('selected');
            }
        });
    },

    // -------------------------------------------------------------------------
    extractFilename: function(file) {
        if (typeof file === 'undefined' || typeof file === '') {
            return;
        }
        var filename = '';
        var lastIdx = file.lastIndexOf('/');
        if (lastIdx >= 0) {
            filename = file.substr(lastIdx + 1);
        }
        return filename;
    },

    // -------------------------------------------------------------------------
    extractPath: function(file) {

        var path = '';
        if (typeof file === 'undefined' || typeof file === '') {
            return path;
        }
        var lastIdx = file.lastIndexOf('/');
        if (lastIdx >= 0) {
            path = file.substr(0, lastIdx);
        }
        return path;
    },

    // -------------------------------------------------------------------------
    getParam: function(theurl, nom) {
        if (typeof theurl === 'undefined' || typeof theurl === '' || typeof nom === 'undefined' || typeof nom === '') {
            return '';
        }
        // Bug en IE, que toma el hash
        if (theurl.indexOf('#') >= 0) {
            theurl = theurl.substr(0, theurl.indexOf('#'));
        }

        var request = theurl;
        if ((nom !== null) && (nom !== 'undefined') && (nom !== '')) {
            var re = new RegExp(nom + '=([^&]*)');
            var found = request.match(re);
            if (found !== null && found.length >= 2) {
                return found[1];
            } else {
                return '';
            }
        }
        return '';
    },

    // -------------------------------------------------------------------------
    showHelp: function(nomItem, relPathProntus) {
        var msg;
        if (nomItem == 'snippet') {
            msg = 'Los Snippets son trozos de código útiles personalizables que pueden ser incrustados en cualquier tipo ' +
                'de archivo a través de este Editor.\n\nLos Snippets disponibles se cargan automáticamente ' +
                'desde los archivos del directorio ' + relPathProntus + '/plantillas/snippets/';
        }
        showModalAlert({
            title: 'Ayuda',
            type: 'green',
            msg: msg
        });
    },

    // -------------------------------------------------------------------------
    accionGuardar: function() {
        if (Editor.loading) {
            return;
        }

        Editor.loading = true;
        Editor.muestraAcciones(false);

        $('#text_file').val(this.aceEditor.getValue());
        $('#sbm_accion').val('Guardar');
        $('#modal-loading').modal();

        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlGuardar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
                $('#modal-loading').modal('hide');
            },
            success: function(resp) {
                if (resp.status == 1) {
                    showSuccessAlert(".get_message", 'El archivo ha sido guardado de manera exitosa');
                } else {
                    Admin.displayMessage(resp.msg, 'error');
                }
            }
        };

        SubmitForm.submitGenericAjax(config, opts);
    },

    // -------------------------------------------------------------------------
    accionNuevo: function(param) {
        if ((param === null) || !Editor.validFileName(param)) {
            return false;
        }
        if (param.indexOf('.') < 0) {
            if (!confirm("El nombre del archivo no posee extensión. ¿Está completamente seguro?\n(Nota: Los archivos sin extensión no se pueden editar)")) {
                return false;
            }
        }

        if (Editor.loading) {
            return;
        }
        Editor.loading = true;
        Editor.muestraAcciones(false);

        $('#nom_new_file').val(param);
        $('#sbm_accion').val('Nuevo');

        var dir = $('#_curr_dir').val();
        var file = dir + '/' + param;
        file = file.replace('//', '/');

        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlGuardar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    Editor.cambiaPathActual(dir, file);
                    showSuccessAlert(".get_message", "El archivo ha sido creado de manera exitosa");
                } else {
                    showWarningAlert(".get_message", resp.msg);
                }
            }
        };
        SubmitForm.submitGenericAjax(config, opts);

    },

    // -------------------------------------------------------------------------
    accionCopiar: function(parametro) {
        var actual = $('#_path_file').val();
        if (actual === '') {
            return
        }
        var actual_dir = actual.substr(0, actual.lastIndexOf('/') + 1);

        if (Editor.loading) {
            return;
        }
        Editor.loading = true;
        Editor.muestraAcciones(false);

        $('#nom_new_file').val(parametro);
        var dir = $('#_curr_dir').val();
        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlCopiar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    Editor.cambiaPathActual(dir, actual_dir + parametro);
                    showSuccessAlert(".get_message", "El archivo ha sido copiado");

                } else {
                    Admin.displayMessage(resp.msg, 'error');
                }
            }
        };
        SubmitForm.submitGenericAjax(config, opts);
    },

    // -------------------------------------------------------------------------
    accionUploadLayer: function(show) {
        if (show) {
            $('#upload').show('fast');
        } else {
            $('#upload').hide();
        }
    },

    // -------------------------------------------------------------------------
    accionUpload: function() {
        if (Editor.loading) {
            return;
        }
        Editor.loading = true;
        Editor.muestraAcciones(false);
        Editor.accionUploadLayer(false);

        if ($('#name_upload').val() == Editor.textUploadName) {
            $('#name_upload').val('');
        }

        var dir = $('#_curr_dir').val();
        $('#subir_archivo [name="_curr_dir"]').val(dir);
        var config = {
            formSelector: '#subir_archivo',
            actionURL: Editor.urlUpload
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
                $('#name_upload').val(Editor.textUploadName);
                $('#file_upload, .upload-content .upload .file').val('');
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    Editor.cambiaPathActual(dir, '');
                    showSuccessAlert(".get_message", resp.msg);
                } else {
                    showWarningAlert(".get_message", resp.msg);

                    $('#msg-global span a').each(function() {
                        $(this).attr('href', '#').attr('class', 'show-extension').css('cursor', 'pointer');
                    });
                }
            }
        };
        SubmitForm.submitGenericAjax(config, opts);

    },

    // -------------------------------------------------------------------------
    accionCerrar: function(tipo) {
        var thePath = $('#_curr_dir').val();
        Editor.cambiaArchivoActual(thePath, '');

        $('#col-arbol .item').removeClass('selected');
    },

    // -------------------------------------------------------------------------
    accionMkdir: function(param) {
        if ((param === null) || !Editor.validFileName(param)) {
            return false;
        }

        if (Editor.loading) {
            return;
        }

        Editor.loading = true;
        Editor.muestraAcciones(false);

        var dir = $('#_curr_dir').val();

        $('#nom_new_file').val(param);
        $('#sbm_accion').val('CrearDir');

        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlGuardar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    Editor.cambiaPathActual(dir, '');
                    showSuccessAlert(".get_message", "El directorio ha sido creado de manera exitosa");
                } else {
                    showInfoAlert("._get_message", resp.msg);
                }
            }
        };

        SubmitForm.submitGenericAjax(config, opts);
    },

    // -------------------------------------------------------------------------
    accionRmdir: function() {
        if (Editor.loading) {
            return;
        }

        Editor.loading = true;
        Editor.muestraAcciones(false);

        $('#type_item').val('dir');
        var dir = $('#_curr_dir').val();
        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlBorrar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    var nextdir = dir.substr(0, dir.lastIndexOf('/'));
                    Editor.cambiaPathActual(nextdir, '');
                    showSuccessAlert(".get_message", resp.msg);
                } else {
                    showInfoAlert("._get_message", resp.msg);
                }
            }
        };

        SubmitForm.submitGenericAjax(config, opts);
    },

    // -------------------------------------------------------------------------
    accionBorrar: function() {
        if (Editor.loading) {
            return;
        }

        Editor.loading = true;
        Editor.muestraAcciones(false);

        $('#type_item').val('file');
        var dir = $('#_curr_dir').val();
        var config = {
            formSelector: '#form-editor',
            actionURL: Editor.urlBorrar
        };
        var opts = {
            complete: function() {
                Editor.loading = false;
                Editor.muestraAcciones(true);
            },
            success: function(resp) {
                if (resp.status == 1) {
                    Editor.loading = false;
                    Editor.cambiaPathActual(dir, '');
                    showSuccessAlert(".get_message", "El archivo ha sido eliminado");
                } else {
                    showWarningAlert(".get_message", resp.msg);
                }
            }
        };

        SubmitForm.submitGenericAjax(config, opts);
    },

    // -------------------------------------------------------------------------
    muestraAcciones: function(flag) {
        if (!flag) {
            $('.botones-accion .acciones').hide();
            $('.botones-accion .loading-action').fadeIn();
        } else {
            $('.botones-accion .loading-action').hide();
            $('.botones-accion .acciones').fadeIn();
        }
    },

    // -----------------------------------------------------------------------------
    insertMarca: function(selectObject) {
        var args = selectObject.options[selectObject.selectedIndex].value;
        var args_arr = args.split(",");

        var nomMarca = args_arr[0];
        var isTag = args_arr[1];
        var param;

        if (nomMarca === '') {
            Editor.selItemCero(selectObject);
            return;
        }

        if (isTag) {
            var marca_open = '';
            var marca_close = '';

            if (nomMarca == 'if') {
                param = prompt("Ingrese parámetros para el if, opciones:\n- Nombre variable (ej: _txt_bajada) ó Variable=valor (ej: NOMBRE=juanito)", "");
                if ((param === null) || !Editor.validMarcaParam(nomMarca, param)) {
                    Editor.selItemCero(selectObject);
                    return;
                }
                marca_open = '\n%%if(' + param + ')%%\n';
                marca_close = '\n%%/if%%\n';

            } else if (nomMarca == 'nif') {
                param = prompt("Ingrese nombre de la variable para el nif (ej: _txt_bajada)", "");
                if ((param === null) || !Editor.validMarcaParam(nomMarca, param)) {
                    Editor.selItemCero(selectObject);
                    return;
                }
                marca_open = '\n%%nif(' + param + ')%%\n';
                marca_close = '\n%%/nif%%\n';

            } else if ((nomMarca.substr(0, 3) == 'ifv') || (nomMarca == 'nifv')) { // ifv, ifvc y nifv
                param = prompt("Ingrese parámetros para " + nomMarca + ": div,res (ej: 2,1)", "");
                if ((param === null) || !Editor.validMarcaParam(nomMarca, param)) {
                    Editor.selItemCero(selectObject);
                    return;
                }
                marca_open = '\n%%' + nomMarca + '(' + param + ')%%\n';
                marca_close = '\n%%/' + nomMarca + '%%\n';

            } else if (nomMarca == 'loop') {
                param = prompt("Ingrese número del loop (ej: 1)", "");
                if ((param === null) || !Editor.validMarcaParam(nomMarca, param)) {
                    Editor.selItemCero(selectObject);
                    return;
                }
                marca_open = '\n%%loop' + param + '%%\n';
                marca_close = '\n%%/loop%%\n';
            }

            var snippet = marca_open + '\t$2' + marca_close;
            // snippets ACE.
            Editor.snippetManager.insertSnippet(Editor.aceEditor, snippet);
            Editor.aceEditor.focus();
        } else {
            var marca = '';

            if (nomMarca == 'macro') {
                param = prompt("Ingrese nombre de archivo de macro (ej: mimacro.html)", "");
                if ((param === null) || !Editor.validMarcaParam(nomMarca, param)) {
                    Editor.selItemCero(selectObject);
                    return;
                }
                marca = '\n%%macro(' + param + ')%%\n';
            } else {
                marca = '%%' + nomMarca + '%%';
            }
            Editor.snippetManager.insertSnippet(Editor.aceEditor, marca);
            Editor.aceEditor.focus();
        }

        Editor.selItemCero(selectObject);
    },

    // -------------------------------------------------------------------------
    selItemCero: function(selectObject) {
        selectObject.options[0].selected = true;
    },

    // -------------------------------------------------------------------------
    validMarcaParam: function(nomMarca, param) {
        var expr = '';

        if (nomMarca == 'if') {
            expr = /^(\w*|\w+ *= *[^=]+)$/;

        } else if (nomMarca == 'nif') {
            expr = /^\w*$/;

            // IFV, IFVC y NIFV
        } else if ((nomMarca.substr(0, 3) == 'ifv') || (nomMarca == 'nifv')) {
            expr = /^([0-9]+,[0-9]+)?$/;

        } else if (nomMarca == 'loop') {
            expr = /^[0-9]+$/;

        } else if (nomMarca == 'macro') {
            expr = /^([^\\\/:\*\?"><\|\s]+)?$/;
        }

        var found = expr.exec(param);
        if (!found) {
            alert('Parámetros no válidos para ' + nomMarca);
            return false;
        }
        return true;
    },

    // -------------------------------------------------------------------------
    validFileName: function(param) {
        var expr = /^([^\\\/:\*\?"><\|\s]+)$/;
        var found = expr.exec(param);
        if (!found) {
            alert('Nombre de archivo no es válido');
            return false;
        }
        return true;
    },

    getProntusSnippets: function() {
        return [{
            name: "if",
            content: "%%if($1)%%\n\t$2\n%%/if%%",
            tabTrigger: "if"
        }, {
            name: "nif",
            content: "%%nif($1)%%\n\t$2\n%%/nif%%",
            tabTrigger: "nif"
        }, {
            name: "macro",
            content: "%%macro($1)%%",
            tabTrigger: "macro"
        }, {
            name: "loop",
            content: "%%loop$1($2)%%\n\t$2\n%%/loop%%",
            tabTrigger: "loop"
        }];
    }
};
